/*
3D Graphics Engine for WebGL, Ohio State University
TA for Real Time Rendering Class -- Tzu-Hsuan Wei

The code source is from http://web.cse.ohio-state.edu/~hewenb/osugl.html
*/


var canvas, gl;

// shaders
var spr;

// camera

window.onload = function init() {
	glInit();
	
	gl = WebGLUtils.setupWebGL( canvas );
    if ( !gl ) { alert( "WebGL isn't available" ); }

    //var vertices = new Float32Array([-1, -1, 0, 1, 1, -1]);

    //  Configure WebGL

    gl.viewport( 0, 0, canvas.width, canvas.height );
    gl.clearColor( 0.8, 0.8, 0.8, 1.0 );
    
    //  Load shaders and initialize attribute buffers
    
    spr = initShaders( gl, "vertex-shader", "fragment-shader" );
    gl.useProgram( spr );
    
    // Load the data into the GPU
    
   // var bufferId = gl.createBuffer();
   // gl.bindBuffer( gl.ARRAY_BUFFER, bufferId );
   // gl.bufferData( gl.ARRAY_BUFFER,vertices, gl.STATIC_DRAW );

    // Associate out shader variables with our data buffer
    
   // var vPosition = gl.getAttribLocation( spr, "vPosition" );
   // gl.vertexAttribPointer( vPosition, 2, gl.FLOAT, false, 0, 0 );
   // gl.enableVertexAttribArray( vPosition );

	glResize();
}

;

var mouseDown = false;
var lastMouseX = null, lastMouseY = null;

function onMouseDown(event) {

}

function onMouseUp(event) {

}

function onMouseMove(event) {
}

function glInit() {
	// init webgl context
	canvas = document.getElementById("canvas");
	gl = canvas.getContext("experimental-webgl");

	gl.clearColor(1.0, 1.0, 1.0, 1.0);
	gl.enable(gl.DEPTH_TEST);

	// add event listeners
	window.addEventListener('resize', glResize, false);
	canvas.onmousedown = onMouseDown;
	document.onmouseup = onMouseUp;
	document.onmousemove = onMouseMove;
}

function glResize() {
	// resize canvas
	canvas.width = window.innerWidth;
	canvas.height = window.innerHeight;

	// reset viewport
	gl.viewportWidth = canvas.width;
	gl.viewportHeight = canvas.height;
	gl.viewport(0, 0, gl.viewportWidth, gl.viewportHeight);
	
	// reset projection matrix
	//camera.updateProjMatrix(45, gl.viewportWidth / gl.viewportHeight, 0.1, 1000.0);
	gl.useProgram(spr);
	//gl.uniformMatrix4fv(spr.projMatrixLoc, false, camera.projMatrix.n);
}



function glRender() {
	gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
		
	gl.useProgram(spr);
	//gl.uniformMatrix4fv(spr.viewMatrixLoc, false, camera.viewMatrix.n);
	
    //gl.drawArrays( gl.TRIANGLES, 0, 3 );
}



// browser-independent requestAnimationFrame
window.requestAnimationFrame = (function() {
	return window.requestAnimationFrame ||
		window.webkitRequestAnimationFrame ||
		window.mozRequestAnimationFrame ||
		window.oRequestAnimationFrame ||
		window.msRequestAnimationFrame ||
		function (callback, element)
		{window.setTimeout(callback, 1000/60);};
}) ();

;
